#include "../zlib/gskzlibinflator.h"
#include "../zlib/gskzlibdeflator.h"
#include "../gskmemory.h"
#include "../gskinit.h"
#include <string.h>

typedef struct _Result Result;
struct _Result
{
  gboolean got_callback;
  guint size;
  guint8 *data;
};

static void
memory_buffer_callback (GskBuffer              *buffer,
		        gpointer                data)
{
  Result *res = data;
  g_assert (!res->got_callback);
  res->got_callback = TRUE;
  res->size = buffer->size;
  res->data = g_malloc (res->size);
  gsk_buffer_peek (buffer, res->data, res->size);
}

int main (int argc, char **argv)
{
  GskStream *inflator;
  GskStream *deflator;
  GskStream *memory_input;
  GskStream *memory_output;
  Result result = { FALSE, 0, NULL };
  GError *error = NULL;
  GskMainLoop *loop;

  gsk_init (&argc, &argv, NULL);
  loop = gsk_main_loop_default ();

  memory_input = gsk_memory_source_new_printf ("hi mom");
  deflator = gsk_zlib_deflator_new (-1, -1);
  inflator = gsk_zlib_inflator_new ();
  memory_output = gsk_memory_buffer_sink_new (memory_buffer_callback, &result, NULL);
  gsk_stream_attach (memory_input, deflator, &error);
  g_assert (error == NULL);
  gsk_stream_attach (deflator, inflator, &error);
  g_assert (error == NULL);
  gsk_stream_attach (inflator, memory_output, &error);
  g_assert (error == NULL);

  while (!result.got_callback)
    gsk_main_loop_run (loop, -1, NULL);

  g_assert (result.size == 6);
  g_assert (memcmp (result.data, "hi mom", 6) == 0);
  return 0;
}
